hdu1078 FatMouse and Cheese(记忆化搜索)

转载请注明出处:http://blog.csdn.net/u012860063

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1078

Problem Description
FatMouse has stored some cheese in a city. The city can be considered as a square grid of dimension n: each grid location is labelled (p,q) where 0 <= p < n and 0 <= q < n. At each grid location Fatmouse has hid between 0 and 100 blocks of cheese in a hole. Now he's going to enjoy his favorite food.

FatMouse begins by standing at location (0,0). He eats up the cheese where he stands and then runs either horizontally or vertically to another location. The problem is that there is a super Cat named Top Killer sitting near his hole, so each time he can run at most k locations to get into the hole before being caught by Top Killer. What is worse -- after eating up the cheese at one location, FatMouse gets fatter. So in order to gain enough energy for his next run, he has to run to a location which have more blocks of cheese than those that were at the current hole.

Given n, k, and the number of blocks of cheese at each grid location, compute the maximum amount of cheese FatMouse can eat before being unable to move.
 
Input
There are several test cases. Each test case consists of

a line containing two integers between 1 and 100: n and k
n lines, each with n numbers: the first line contains the number of blocks of cheese at locations (0,0) (0,1) ... (0,n-1); the next line contains the number of blocks of cheese at locations (1,0), (1,1), ... (1,n-1), and so on.
The input ends with a pair of -1's. 

Output
For each test case output in a line the single integer giving the number of blocks of cheese collected. 

Sample Input
3 1 1 2 5 10 11 6 12 12 7 -1 -1
 
Sample Output
37

Source

题目大意:

    有一个地图。上面有正整数值,然后要求从(0, 0)点出发,每次仅仅能走向比当前点值更大的点,而且每次能够向四个方向走最多k步,要求走到最后所能得到的最大值。

解题思路:

              因为题目要求有四个方向能够走。所以想到搜索,而要求走得最优解。所以能够用记忆化搜索。动态规划基础题,只是相当经典。


代码例如以下:(93ms)

Run ID Submit Time Judge Status Pro.ID Exe.Time Exe.Memory Code Len. Language Author
10907677 2014-06-26 10:55:49 Accepted 1078 93MS 392K 910 B G++ 天资4747tym

#include <cstdio>
#include <cstring>

int dp[147][147],map[147][147];
int n,k;
int xx[4]={0,0,1,-1};
int yy[4]={1,-1,0,0};

int DFS(int x,int y)
{
	int ans = 0,MAX = 0;
	if(!dp[x][y])
	{
		for(int i = 1; i <= k; i++)
		{
			for(int j = 0; j < 4; j++)
			{
				int dx = x+xx[j]*i;
				int dy = y+yy[j]*i;
				if(dx>=0 && dx<n && dy>=0 && dy<n && map[x][y]<map[dx][dy])
				{
					ans = DFS(dx,dy);//每条路径能吃到的奶酪量
					if(ans > MAX)
						MAX = ans;
				}
			}
			dp[x][y] = MAX+map[x][y];//从dp[x][y]開始能吃到的最大奶酪量
		}
	}
	return dp[x][y];
}

int main()
{
	while(~scanf("%d%d",&n,&k))
	{
		if(n == -1 && k == -1)
			break;
		memset(dp,0,sizeof(dp));
		memset(map,0,sizeof(map));
		for(int i = 0; i < n; i++)
		{
			for(int j = 0; j < n; j++)
			{
				scanf("%d",&map[i][j]);
			}
		}
		int TT = DFS(0,0);
		printf("%d
",TT);
	}
	return 0;
}


原文地址:https://www.cnblogs.com/liguangsunls/p/6952788.html